﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace tanciskola
{
    class Pair
    {
        public string Dance { get; set; }
        public string Boy { get; set; }
        public string Girl { get; set; }

        public Pair(string dance, string girl, string boy)
        {
            Dance = dance;
            Girl = girl;
            Boy = boy;

        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            List<Pair> pairs = new List<Pair>();

            //adatok beolvasása, tárolása
            Feladat01(pairs);
            //első és utolsó tánc
            Feladat02(pairs);
            //sambát táncoló párok száma
            Feladat03(pairs);
            //Vilma táncai
            Feladat04(pairs, "Vilma");
            //Vilma partnere egy adott táncban
            Feladat05(pairs, "Vilma");
            //Lányok és fiúk listája - fájlba
            Feladat06(pairs);
            //legtöbbet táncolók
            Feladat07();

            Console.ReadKey();
        }

        private static void Feladat01(List<Pair> list)
        {
            Console.WriteLine("1. feladat:");
            using (System.IO.StreamReader sr = new System.IO.StreamReader("tancrend.txt"))
            {
                while (!sr.EndOfStream)
                {
                    list.Add(new Pair(sr.ReadLine(), sr.ReadLine(), sr.ReadLine()));
                }
            }
            Console.WriteLine("Adatbeolvasás kész");
        }

        private static void Feladat02(List<Pair> list)
        {
            Console.WriteLine("2. feladat:");
            Console.WriteLine("\tAz első tánc:\t{0}\n\tAz utolsó tánc:\t{1}", list[0].Dance, list[list.Count() - 1].Dance);
        }

        private static void Feladat03(List<Pair> list)
        {
            Console.WriteLine("3. feladat:");
            int i = 0;
            while (i < list.Count() && list[i].Dance != "samba")
                i++;
            int db = 1;
            while (i < list.Count() && list[i].Dance == "samba")
            {
                i++;
                db++;
            }
            Console.WriteLine("{0} pár táncolt sambát.", db);
        }

        private static List<Pair> OneGirl(List<Pair> list, string name)
        {
            List<Pair> v = new List<Pair>();
            foreach (Pair p in list)
            {
                if (p.Girl == name)
                {
                    v.Add(p);
                }
            }
            return v;
        }

        private static void Feladat04(List<Pair> list, string name)
        {
            Console.WriteLine("4. feladat:");
            Console.Write("{0} táncai:", name);
            List<Pair> nlist = OneGirl(list, name);
            foreach (Pair p in nlist)
            {
                Console.Write(" " + p.Dance + ",");
            }
            Console.WriteLine("\b ");
        }

        private static void Feladat05(List<Pair> list, string name)
        {
            Console.WriteLine("5. feladat:");
            Console.Write("Adja meg a tánc nevét: ");
            string dance = Console.ReadLine();
            List<Pair> nlist = OneGirl(list, name);
            int n = nlist.Count();
            int i = 0;
            while (i < n && nlist[i].Dance != dance)
            {
                i++;
            }
            if (i < n)
            {
                Console.WriteLine("A {1} bemutatóján Vilma párja {0} volt", nlist[i].Boy, dance);
            }
            else
            {
                Console.WriteLine("{1} nem táncolt {0}-t", dance, name);
            }

        }

        static Dictionary<string, int> girls = new Dictionary<string, int>();
        //static List<string> boys = new List<string>();
        static Dictionary<string, int> boys = new Dictionary<string, int>();

        private static void Feladat06(List<Pair> list)
        {
            Console.WriteLine("6. feladat:");
            foreach (Pair p in list)
            {
                if (girls.ContainsKey(p.Girl))
                {
                    girls[p.Girl]++;
                }
                else
                {
                    girls.Add(p.Girl, 1);
                }
                if (boys.ContainsKey(p.Boy))
                {
                    boys[p.Boy]++;
                }
                else
                {
                    boys.Add(p.Boy, 1);
                }

            }
            using (System.IO.StreamWriter sw = new System.IO.StreamWriter("szereplok.txt"))
            {
                string output = "Lányok:";
                foreach (KeyValuePair<string, int> g in girls)
                {
                    output += " " + g.Key + ",";
                }
                sw.WriteLine(output.Substring(0, output.Length - 1));

                output = "Fiúk:";
                foreach (KeyValuePair<string, int> b in boys)
                {
                    output += " " + b.Key + ",";
                }
                sw.WriteLine(output.Substring(0, output.Length - 1));
            }
            Console.WriteLine("Fájlbaírás kész");
        }

        private static void Feladat07()
        {
            Console.WriteLine("7. feladat");

            int maxb = 0;
            foreach (KeyValuePair<string, int> b in boys)
            {
                if (b.Value > maxb)
                {
                    maxb = b.Value;
                }
            }
            Console.WriteLine("Legtöbbet táncoló fiúk:");
            foreach (KeyValuePair<string, int> b in boys)
            {
                if (b.Value == maxb)
                {
                    Console.WriteLine("\t" + b.Key);
                }
            }

            int maxg = 0;
            foreach (KeyValuePair<string, int> g in girls)
            {
                if (g.Value > maxg)
                {
                    maxg = g.Value;
                }
            }
            Console.WriteLine("Legtöbbet táncoló lányok:");
            foreach (KeyValuePair<string, int> g in girls)
            {
                if (g.Value == maxg)
                {
                    Console.WriteLine("\t" + g.Key);
                }
            }
        }
    }
}
